# Analyseur syntaxique des formules logiques

def parse1(s):
    f, reste = parse2(s)
    if len(reste) >= 3 and reste[0:3] == '<->':
        f1, reste1 = parse1(reste[3:])
        return (('EQV', f, f1), reste1)
    else:
        return (f, reste)

def parse2(s):
    f, reste = parse3(s)
    if len(reste) >= 2 and reste[0:2] == '->':
        f1, reste1 = parse2(reste[2:])
        return (('IMPL', f, f1), reste1)
    else:
        return (f, reste)

def parse3(s):
    f, reste = parse4(s)
    if len(reste) >= 1 and reste[0] == '+':
        f1, reste1 = parse3(reste[1:])
        return (('OR', f, f1), reste1)
    else:
        return (f, reste)

def parse4(s):
    f, reste = parseI(s)
    if len(reste) >= 1 and reste[0] == '.':
        f1, reste1 = parse4(reste[1:])
        return (('AND', f, f1), reste1)
    else:
        return (f, reste)

def parseI(s):
    if s[0] == '(':
        f, reste = parse1(s[1:])
        assert reste[0] == ')'
        return (f, reste[1:])
    elif s[0] == '-':
        f, reste = parseI(s[1:])
        return (('NOT', f), reste)
    else:
        return (('VAR', s[0]), s[1:])

def parse_prop(s):
    f, reste = parse1(s)
    return f

# Conversion vers une chaîne de caractères

def type_prop(P): return P[0]
def left(P): return P[1]
def right(P): return P[2]

symbol = {'NOT': '\u2142', 'AND': '\u22C0', 'OR': '\u22C1', 'IMPL': '\u21D2', 'EQV': '\u21D4'}

prio = {'VAR': 15, 'NOT': 10, 'AND': 8, 'OR': 6, 'IMPL': 4, 'EQV': 2}

def paren(s, f1, f):
    if prio[f1[0]] <= prio[f[0]]: return '(' + s + ')'
    else: return s

def to_string(f):
    if f[0] == 'VAR': return f[1]
    elif f[0] == 'NOT':
        f1 = left(f)
        s1 = to_string(f1)
        return symbol['NOT'] + paren(s1, f1, f)
    else:
        smb = symbol[f[0]]
        f1 = left(f)
        f2 = right(f)
        s1 = to_string(f1)
        s2 = to_string(f2)
        return paren(s1, f1, f) + smb + paren(s2, f2, f)
